//3456789_123456789_123456789_123456789_123456789_123456789_123456789_123456789_
//
// Proj1View.cpp : implementation of the CProj1View class
//

#include "stdafx.h"
#include "Proj1.h"

#include "Proj1Doc.h"
#include "Proj1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProj1View

IMPLEMENT_DYNCREATE(CProj1View, CView)

BEGIN_MESSAGE_MAP(CProj1View, CView)
	//{{AFX_MSG_MAP(CProj1View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProj1View construction/destruction

CProj1View::CProj1View()
{
	// TODO: add construction code here

}

CProj1View::~CProj1View()
{
}

BOOL CProj1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	m_GLstuff.PreCreate_GL(cs);		// Create OpenGL's rendering context.
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CProj1View drawing

void CProj1View::OnDraw(CDC* pDC)
{
	CProj1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	m_GLstuff.drawOpenGL(pDC);		// Do OpenGL's drawing.
}

/////////////////////////////////////////////////////////////////////////////
// CProj1View printing

BOOL CProj1View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CProj1View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CProj1View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CProj1View diagnostics

#ifdef _DEBUG
void CProj1View::AssertValid() const
{
	CView::AssertValid();
}

void CProj1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CProj1Doc* CProj1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CProj1Doc)));
	return (CProj1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CProj1View message handlers

int CProj1View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
CClientDC clientDC(this);	// Get the Windows GDI 'Device Context'

	m_GLstuff.OnCreate_GL(clientDC);	// Use it for OpenGL setup.	
	m_GLstuff.m_bAnimate=TRUE;		// enable animation.
	CWnd::SetTimer(1,15,NULL);		// Brute-force timer #1;
	return 0;
}

void CProj1View::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	m_GLstuff.OnDestroy_GL();	// Discard OpenGL's rendering context.
	CWnd::KillTimer(1);			// Shut down animation timer #1.
}

BOOL CProj1View::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	//return CView::OnEraseBkgnd(pDC);	
	return TRUE;	// no screen clearing!
}

void CProj1View::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
		if(m_GLstuff.m_bAnimate==TRUE)		// If we're animating,
		{
			m_GLstuff.tick_GL();			// Advance animation by 1 timestep
			Invalidate(FALSE);				// Trigger windows redrawing.
		}			
	
	CView::OnTimer(nIDEvent);
}

void CProj1View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
			CClientDC our_winDC(this);				// Grab Win. Device Context
													// (to link with OpenGL )
			m_GLstuff.OnSize_GL(our_winDC,cx,cy);	// Re-set GL viewing matrix.
	
}

void CProj1View::OnLButtonDown(UINT nFlags, CPoint point) 
{
CWnd *pFocus;						// tmp: which window is active?
CClientDC cDC(this);				// get window's drawing area:
	CView::OnLButtonDown(nFlags, point); // Always run the Windows' default 
									 // mouse routine first.
	// TODO: Add your message handler code here and/or call default
	pFocus = CWnd::GetFocus();
	if(pFocus == this)
	{
		SetCapture( );  // Capture the mouse until button up
		m_GLstuff.LButtonDown(cDC, point);	
						// Now go to user's mouse routines
	}
}

void CProj1View::OnLButtonUp(UINT nFlags, CPoint point) 
{
// TODO: Add your message handler code here, and/or call default
CClientDC cDC(this);			// get window's drawing area:
	
	if( GetCapture( ) != this )	// does our window(view) control the mouse?
	{							// No! mouse isn't ours; run the 
		CView::OnLButtonUp(nFlags, point);	// Windows default mouse handler.
		return;
	}							// Yes. save the mouse position, and
	m_GLstuff.LButtonUp(cDC,point);	// Make the OpenGL object move around.
	ReleaseCapture( );			// Release our mouse capture; we're done.
}

void CProj1View::OnMouseMove(UINT nFlags, CPoint point) 
{
CClientDC cDC(this);			// get window's drawing area:
//
	if( GetCapture( ) != this )	// We capture ONLY when LButton is down..
	{							// No! mouse isn't ours; do default stuff.
		CView::OnMouseMove(nFlags, point);
		return;
	}							// Yes. Mouse dragging with left button down.
									 // keep previous mouse position, and
	m_GLstuff.LMouseDrag(cDC,point); // call the OpenGL part of program; give it
								// the current mouse position.
}

void CProj1View::OnFileOpen() 
{
	// TODO: Add your command handler code here
	m_GLstuff.OnFileOpen(CWnd::m_hWnd);		// Custom file Open...
}

void CProj1View::OnFileSave() 
{
	// TODO: Add your command handler code here
	m_GLstuff.OnFileSave(CWnd::m_hWnd);		// Custom file Save...

}

void CProj1View::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	m_GLstuff.OnFileSave(CWnd::m_hWnd);		// Custom file Save...
	
}

void CProj1View::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	m_GLstuff.keyDown(nChar, nRepCnt, nFlags);
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CProj1View::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	m_GLstuff.keyUp(nChar, nRepCnt, nFlags);
	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}
